RAISERROR ('Dont run the whole script, just run sections at a time', 20, 1)  WITH LOG;

-- Step1 Restore Data to original Table (need to disableFK)
USE [CorruptionChallenge4]
GO

ALTER TABLE [dbo].[Orders] DROP CONSTRAINT [FK_Orders_People]
GO

SET IDENTITY_INSERT Customers ON

truncate table [dbo].[Customers]; -- Truncating cleans up the corruption

INSERT INTO [dbo].[Customers](id, FirstName, MiddleName, LastName)
Select 
	id, FirstName, MiddleName, LastName
from [dbo].[Customers_Copy1];

SET IDENTITY_INSERT Customers OFF

-- Check Corruption fixed
DBCC CHECKDB('CorruptionChallenge4') WITH ALL_ERRORMSGS, NO_INFOMSGS


-- Clean UP 
-- (a) Restore FK
ALTER TABLE [dbo].[Orders]  WITH CHECK ADD  CONSTRAINT [FK_Orders_People] FOREIGN KEY([customerId])
REFERENCES [dbo].[Customers] ([id])
GO

ALTER TABLE [dbo].[Orders] CHECK CONSTRAINT [FK_Orders_People]
GO

-- (b) Drop Temporary objects
USE [CorruptionChallenge4]
GO

DROP TABLE [dbo].[Customers_Copy]
DROP TABLE [dbo].[Customers_Copy1]
DROP TABLE [dbo].[tmpCustomerData]
DROP FUNCTION [dbo].[HexStrToVarBinary]

GO
--(c) Restore Triggers
ENABLE TRIGGER [noDropTables] ON DATABASE;
ENABLE TRIGGER [noNewTables] ON DATABASE;

-- (d) Check Object Count restored to 5
SELECT Count(*)
FROM sys.objects
WHERE is_ms_shipped = 0;




-- (e) Check Data
SELECT * FROM dbo.Customers;



SELECT * FROM dbo.Customers
WHERE id in (510900, 510901)

510900	Steve	M	Stedman
510901	William	V	STARK

-- 


-- one final check.
DBCC CHECKDB('CorruptionChallenge4') WITH ALL_ERRORMSGS, NO_INFOMSGS

